﻿using BepInEx;
using RoR2;
using System;
using System.Security;
using System.Security.Permissions;
using System.Threading.Tasks;
using System.Linq;
using MonoMod.Cil;
using MonoMod.RuntimeDetour;
using Mono.Cecil.Cil;
using System.Collections.Generic;
using R2API;
using static R2API.RecalculateStatsAPI;

#pragma warning disable CS0618
[module: UnverifiableCode]
[assembly: SecurityPermission(SecurityAction.RequestMinimum, SkipVerification = true)]
#pragma warning restore CS0618

namespace HolyHolyHoly
{
    [BepInPlugin("xyz.yekoc.Holy", "HolyHolyHOLY","1.0.3" )]
    [BepInDependency("com.bepis.r2api",BepInDependency.DependencyFlags.HardDependency)]
    public class HolyPlugin : BaseUnityPlugin
    {
	public class HolyData{
	  public StatHookEventArgs args;
	  public bool OnLevel;
	  public bool statsDirty;
	}
	ILHook sprint,ih;
	Hook h;
	public event On.RoR2.CharacterBody.hook_RecalculateStats HookStealer;
	static Dictionary<CharacterBody,HolyData> queue = new Dictionary<CharacterBody,HolyData>();
	ILContext.Manipulator Taskifier = ((il) => {
		ILCursor c = new ILCursor(il);
		while(c.TryGotoNext(x => x.MatchCallOrCallvirt(typeof(CharacterBody).GetMethod("RecalculateStats")))){
		 c.Remove();
		 c.EmitDelegate<Action<CharacterBody>>((cb) => {if(!queue.ContainsKey(cb)) queue.Add(cb,new HolyData()); queue[cb].statsDirty = true; cb.statsDirty = false;});
		}
	  });

	private void Awake(){
	  IL.RoR2.CharacterBody.FixedUpdate += Taskifier;
	  //IL.RoR2.CharacterBody.Start += Taskifier; //Causes Instant Death on spawn.
	  IL.RoR2.CharacterMaster.OnBodyStart += Taskifier;
	  IL.RoR2.CharacterBody.OnCalculatedLevelChanged += OnLevelUp;
	  sprint = new ILHook(typeof(CharacterBody).GetProperty("isSprinting").GetSetMethod(),Taskifier);
	  if(RecalculateStatsAPI.Loaded){
		ih = new ILHook(typeof(RecalculateStatsAPI).GetMethod("HookRecalculateStats",(System.Reflection.BindingFlags)(-1)),RecalculateStatsAPIRuiner);
		h = new Hook(typeof(RecalculateStatsAPI).GetMethod("GetStatMods",(System.Reflection.BindingFlags)(-1)),typeof(HolyPlugin).GetMethod("RecalculateStatsAPIRuiner2",(System.Reflection.BindingFlags)(-1)));
	  }
	  IL.RoR2.CharacterBody.RecalculateStats += UnVisualize;
	}

	private void OnDestroy(){
	  IL.RoR2.CharacterBody.FixedUpdate -= Taskifier;
	  IL.RoR2.CharacterMaster.OnBodyStart -= Taskifier;
	  IL.RoR2.CharacterBody.OnCalculatedLevelChanged -= OnLevelUp;
	  IL.RoR2.CharacterBody.RecalculateStats -= UnVisualize;
	  sprint.Undo();
	  if(RecalculateStatsAPI.Loaded){
	    h.Undo();
	    ih.Undo();
	  }
	}

	private void OnLevelUp(ILContext il){
		ILCursor c = new ILCursor(il);
		if(c.TryGotoNext(x => x.MatchRet())){
                 var label = c.MarkLabel();
		 c.Index -= 1;
		 c.EmitDelegate<Action<CharacterBody>>((CharacterBody cb) => {if(!queue.ContainsKey(cb)) queue.Add(cb,new HolyData()); queue[cb].OnLevel = true;});
                 c.Emit(OpCodes.Br,label);
                 c.Emit(OpCodes.Ldarg_0);
                }
	}

	private void UnVisualize(ILContext il){
		ILCursor c = new ILCursor(il);
		if(c.TryGotoNext(x => x.MatchLdarg(0),x => x.MatchCallOrCallvirt(typeof(CharacterBody).GetMethod("UpdateAllTemporaryVisualEffects",(System.Reflection.BindingFlags)(-1))))){
		  c.MoveAfterLabels();
                  c.Index += 2;
		  var label = c.MarkLabel();
                  c.Index -=2;
                  c.Emit(OpCodes.Br,label);
		}

	}

/* Doesn't work how I wished it would,HookGen doesn't expose the hook objects/trampolines through the events. 
	private void DoubleHeresyForCompat(bool active){
	   if(active){
	     foreach(var hook in ((EventHandler)typeof(On.RoR2.CharacterBody).GetField("RecalculateStats",(System.Reflection.BindingFlags)(-1))?.GetValue(null))?.GetInvocationList().ToList()){
	       HookStealer += hook as On.RoR2.CharacterBody.hook_RecalculateStats;
	       On.RoR2.CharacterBody.RecalculateStats -= hook as On.RoR2.CharacterBody.hook_RecalculateStats;
	     }
	   }
	   else{	
	     foreach(var hook in HookStealer.GetInvocationList().ToList()){
	       HookStealer -= hook as On.RoR2.CharacterBody.hook_RecalculateStats;
	       On.RoR2.CharacterBody.RecalculateStats += hook as On.RoR2.CharacterBody.hook_RecalculateStats;
	     }
	   }
	}
*/
	private void RecalculateStatsAPIRuiner(ILContext il){
				ILCursor c = new ILCursor(il);
				ILLabel label = c.DefineLabel();
                                if(c.TryGotoNext(MoveType.After,x=> x.MatchCallOrCallvirt(typeof(ILCursor).GetMethod("EmitDelegate").MakeGenericMethod(typeof(Action<CharacterBody>))),x=>x.MatchPop())){
                                 label = c.MarkLabel();
                                 if(c.TryGotoPrev(MoveType.After,x => x.MatchPop(),x => x.MatchLdloc(out _))){
				   c.EmitDelegate<Action<ILCursor>>((cursor) => {cursor.EmitDelegate<Action<CharacterBody>>((body) => {if(!queue.ContainsKey(body)) RecalculateStatsAPI.GetStatMods(body);});});
                                   c.Emit(OpCodes.Br,label);
                                   c.Emit(OpCodes.Ldloc_0);
                                 }
                                }
	}
	static private void RecalculateStatsAPIRuiner2(Action<CharacterBody> orig,CharacterBody cb){
				orig(cb);
				if(!queue.ContainsKey(cb))
				 queue.Add(cb,new HolyData());
				queue[cb].args = RecalculateStatsAPI.StatMods;
	}
	private void FixedUpdate(){
		if(Run.instance){
		 foreach(CharacterBody body in queue.Keys.ToList()){
		   if(body.healthComponent && body.healthComponent.alive){
		     if(RecalculateStatsAPI.Loaded && queue[body].statsDirty){
		      RecalculateStatsAPI.GetStatMods(body);
		     }
		   }
		   else{
		     queue.Remove(body);
		   }
		 }
		Parallel.ForEach(queue.Keys.Where((b) => queue[b].statsDirty), body =>{
			  body.RecalculateStats();
		});
		foreach(var pair in queue){
			if(pair.Key.healthComponent){
			 if(pair.Value.OnLevel)
			   pair.Key.OnLevelUp();
			 pair.Key.UpdateAllTemporaryVisualEffects();
			 HookStealer?.Invoke((body) => {},pair.Key); 
			}
			pair.Value.statsDirty = false;
			pair.Value.OnLevel = false;
		}
	 }
	}
    }
}
